function (indx, eArgsFile, ofn, extraArgs = "", seed = -1, max_tries = 1, 
    exePostfix = "") 
{
    source("myglobaldefs.r")
    DEBUG_MASTER("func ----> runNLMESample() ")
    DEBUG_MASTER(paste("exePostfix", exePostfix))
    lines = readLines("myglobaldefs.r")
    if (jobType != "BOOTSTRAP") {
        engine = 1
        column_def_file = ""
        data_file = ""
    }
    if (UsingBatchTools == TRUE && !(tolower(parallelMethod) == 
        "multicore" || tolower(parallelMethod) == "none")) {
        baseDirectory = getwd()
        baseJobDirectory = sprintf("%s/registry", baseDirectory)
    }
    else {
        baseJobDirectory = getwd()
        baseDirectory = baseJobDirectory
    }
    if (indx == 0) {
        workingDir = paste0(baseJobDirectory, "/")
        statusFile = sprintf("%s/S_%03d.status", baseDirectory, 
            indx)
        statusBackupFile = sprintf("%s/S_%03d.status.bak", baseDirectory, 
            indx)
        logFile = paste(workingDir, ".status", sep = "")
        outFile = paste(workingDir, ofn, sep = "")
        workPath = baseJobDirectory
        newFilePath = sprintf("%s/exNLME%s", baseJobDirectory, 
            exeFileExtension)
    }
    else {
        baseIndx = indx%%100
        workingDir1 = sprintf("%s%sjobs%s%02d%s", baseJobDirectory, 
            .Platform$file.sep, .Platform$file.sep, baseIndx, 
            .Platform$file.sep)
        workingDir = sprintf("%s%sjobs%s%02d%s%d%s", baseJobDirectory, 
            .Platform$file.sep, .Platform$file.sep, baseIndx, 
            .Platform$file.sep, indx, .Platform$file.sep)
        statusFile = sprintf("%s/S_%03d.status", baseDirectory, 
            indx)
        statusBackupFile = sprintf("%s/S_%03d.status.bak", baseDirectory, 
            indx)
        logFile = paste(workingDir, ".status", sep = "")
        outFile = paste(workingDir, ofn, sep = "")
        mkdir(workingDir1)
        mkdir(workingDir)
        workPath = sprintf("%s/jobs/%02d/%d/", baseJobDirectory, 
            baseIndx, indx)
        newFilePath = sprintf("%s/jobs/%02d/%d/exNLME%s", baseJobDirectory, 
            baseIndx, indx, exeFileExtension)
        for (f in unlist(strsplit(files_to_copy, split = " "))) {
            file.copy(sprintf("%s", f), sprintf("%s/%s", workingDir, 
                f))
        }
        file.copy(sprintf("%s", eArgsFile), sprintf("%s/%s", 
            workingDir, eArgsFile))
    }
    if (nchar(eArgsFile) > 0) 
        extraArgsFile = sprintf("@%s", eArgsFile)
    else extraArgsFile = eArgsFile
    MpiExecutable = get("MpiExecutable", envir = .GlobalEnv)
    MpiArgument = get("MpiArgument", envir = .GlobalEnv)
    MpiNumCores = get("MpiNumCores", envir = .GlobalEnv)
    MpiLocal = get("MpiLocal", envir = .GlobalEnv)
    MpiExecutable = gsub(".exe", paste0(exePostfix, ".exe"), 
        MpiExecutable, fixed = TRUE)
    DEBUG_MASTER(paste("MpiNumCores", MpiNumCores))
    if (submissionPlatform == "unix") {
        if (nchar(column_def_file) > 0) {
            commandString = sprintf("%s/execNLMECmd%s RUN %s/%s %s %s %s %s \"\" NLME_DIR \"\" \" %s %s %s %s\" \"\" %s", 
                baseDirectory, exeFileExtension, baseDirectory, 
                model_file, workingDir, MpiArgument, MpiLocal, 
                MpiNumCores, extraArgs, extraArgsFile, column_def_file, 
                data_file, exePostfix)
        }
        else {
            commandString = sprintf("%s/execNLMECmd%s RUN %s/%s %s %s %s %s \"\" NLME_DIR \"\" \" %s %s \" \"\" %s", 
                baseDirectory, exeFileExtension, baseDirectory, 
                model_file, workingDir, MpiArgument, MpiLocal, 
                MpiNumCores, extraArgs, extraArgsFile, exePostfix)
        }
        cat("#!/bin/ksh", file = newFilePath, sep = "\n", append = FALSE)
        cat("###set -x", file = newFilePath, sep = "\n", append = TRUE)
        cat("typeset -i numTries", file = newFilePath, sep = "\n", 
            append = TRUE)
        cat("typeset -i bootSeed", file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(paste("cd ", workingDir), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(sprintf("ln -s %s/%s %s", baseDirectory, MpiExecutable, 
            workPath), file = newFilePath, sep = "\n", append = TRUE)
        cat(sprintf("chmod 777 %s ", MpiExecutable), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("echo 'RUNNING' >", logFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("echo 'RUNNING' >", statusFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("echo '", format(Sys.time(), "%Y-%m-%d %H:%M:%S %Z"), 
            "' >>", statusFile), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(sprintf("maxTries=%d", max_tries), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(sprintf("numTries=1"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(sprintf("bootSeed=%d", seed), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat("startTime=`date +\"%x %T\"`", file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(sprintf("while [ ${numTries} -le ${maxTries} ]; do"), 
            file = newFilePath, sep = "\n", append = TRUE)
        cat(commandString, file = newFilePath, sep = "\n", append = TRUE)
        cat("stopTime=`date +\"%x %T\"`", file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(sprintf("((numTries++))"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(sprintf("bootSeed=${bootSeed}+1"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat("sleep 1", file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("if [ -s ", outFile, " ]"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat("then", file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("echo 'SUCCESS' >", logFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("echo 'SUCCESS' >", statusFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("echo ${startTime} >>", statusFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("echo ${stopTime} >>", statusFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("break"), file = newFilePath, sep = "\n", append = TRUE)
        cat("else", file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("if [  ${numTries} -ge ${maxTries} ]"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat("then", file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("echo 'FAILED' >", logFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("echo 'FAILED' >", statusFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat("fi", file = newFilePath, sep = "\n", append = TRUE)
        cat("fi", file = newFilePath, sep = "\n", append = TRUE)
        cat(sprintf("done"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(paste("if [ -s ", outFile, " ]"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat("then", file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("echo 'SUCCESS' >", logFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("echo 'SUCCESS' >", statusFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("echo ${startTime} >>", statusFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("echo ${stopTime} >>", statusFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat("else", file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("echo 'FAILED' >", logFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("echo 'FAILED' >", statusFile), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat("fi", file = newFilePath, sep = "\n", append = TRUE)
        Sys.chmod(newFilePath, mode = "0777", use_umask = TRUE)
        if (indx != 0 && (toupper(parallelMethod) == "MULTICORE" || 
            toupper(parallelMethod) == "NONE")) 
            system(paste("nohup ", newFilePath, " 2>&1 > log &"))
        else system(paste0(newFilePath, "  2>&1 > log.", indx, 
            " "))
    }
    else {
        if (nchar(column_def_file) > 0) {
            commandString = sprintf("CALL %s\\execNLMECmd%s RUN %s\\%s %s %s %s %s \"\" NLME_DIR \"\" \" %s %s %s %s\" \"\" %s", 
                gsub("/", "\\", baseDirectory, fixed = TRUE), 
                exeFileExtension, gsub("/", "\\", baseDirectory, 
                  fixed = TRUE), model_file, gsub("/", "\\", 
                  workingDir, fixed = TRUE), MpiArgument, MpiLocal, 
                MpiNumCores, extraArgs, extraArgsFile, column_def_file, 
                data_file, exePostfix)
        }
        else {
            commandString = sprintf("CALL %s\\execNLMECmd%s RUN %s\\%s %s %s %s %s \"\" NLME_DIR \"\" \" %s %s \" \"\" %s", 
                gsub("/", "\\", baseDirectory, fixed = TRUE), 
                exeFileExtension, gsub("/", "\\", baseDirectory, 
                  fixed = TRUE), model_file, gsub("/", "\\", 
                  workingDir, fixed = TRUE), MpiArgument, MpiLocal, 
                MpiNumCores, extraArgs, extraArgsFile, exePostfix)
        }
        cat("@echo off", file = newFilePath, sep = "\n", append = FALSE)
        if (indx != 0) 
            cat(sprintf("copy %s\\%s %s\\%s", gsub("/", "\\", 
                baseDirectory, fixed = TRUE), MpiExecutable, 
                gsub("/", "\\", workPath, fixed = TRUE), MpiExecutable), 
                file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("@echo RUNNING>", gsub("/", "\\", logFile, 
            fixed = TRUE)), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("@echo RUNNING>", gsub("/", "\\", statusFile, 
            fixed = TRUE)), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("@echo '", format(Sys.time(), "%Y-%m-%d %H:%M:%S %Z"), 
            "' >>", gsub("/", "\\", statusFile, fixed = TRUE)), 
            file = newFilePath, sep = "\n", append = TRUE)
        cat(sprintf("set maxTries=%d", max_tries), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(sprintf("set statusRetries=1"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(sprintf("set numTries=1"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(sprintf("set bootSeed=%d", seed), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat("set startTime=%DATE:~10,4%/%DATE:~4,4% %TIME%", 
            file = newFilePath, sep = "\n", append = TRUE)
        cat(sprintf(":DoItAgain"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(commandString, file = newFilePath, sep = "\n", append = TRUE)
        cat("set stopTime=%DATE:~10,4%/%DATE:~4,4% %TIME%", file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(sprintf(":RetryStatus"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat("if %statusRetries% GTR 20 goto DONE", file = newFilePath, 
            sep = "\n", append = TRUE)
        cat("SET /A statusRetries=%statusRetries%+1", file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("if EXIST ", gsub("/", "\\", outFile, fixed = TRUE), 
            " goto SUCCESS"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(paste("SET /A numTries=%numTries%+1"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("SET /A bootSeed=%bootSeed%+1"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("if %numTries% LEQ %maxTries% goto DoitAgain"), 
            file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("@echo FAILED>", gsub("/", "\\", logFile, fixed = TRUE)), 
            file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("move ", gsub("/", "\\", statusFile, fixed = TRUE), 
            gsub("/", "\\", statusBackupFile, fixed = TRUE)), 
            file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("if NOT ERRORLEVEL 0 ("), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("@echo %ERRORLEVEL%"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("@echo File is locked on move"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("timeout /t 1"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(paste("goto RetryStatus"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(paste(")"), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("@echo FAILED>", gsub("/", "\\", statusFile, 
            fixed = TRUE)), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("if NOT ERRORLEVEL 0 ("), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("@echo %ERRORLEVEL%"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("@echo File is locked on write"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("goto RetryStatus"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(paste(")"), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("goto DONE"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(paste(":SUCCESS"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(paste("@echo SUCCESS>", gsub("/", "\\", logFile, 
            fixed = TRUE)), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("move ", gsub("/", "\\", statusFile, fixed = TRUE), 
            gsub("/", "\\", statusBackupFile, fixed = TRUE)), 
            file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("if NOT ERRORLEVEL 0 ("), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("@echo %ERRORLEVEL%"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("@echo File is locked on move"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("timeout /t 1"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(paste("goto RetryStatus"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(paste(")"), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("@echo SUCCESS>", gsub("/", "\\", statusFile, 
            fixed = TRUE)), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("if NOT ERRORLEVEL 0 ("), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("@echo %ERRORLEVEL%"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("@echo File is locked on write"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("goto RetryStatus"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(paste(")"), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("@echo %startTime% >>", gsub("/", "\\", statusFile, 
            fixed = TRUE)), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("if NOT ERRORLEVEL 0 ("), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("@echo %ERRORLEVEL%"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("@echo File is locked on write"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("goto RetryStatus"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(paste(")"), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("@echo %stopTime% >>", gsub("/", "\\", statusFile, 
            fixed = TRUE)), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("if NOT ERRORLEVEL 0 ("), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("@echo %ERRORLEVEL%"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("@echo File is locked on write"), file = newFilePath, 
            sep = "\n", append = TRUE)
        cat(paste("goto RetryStatus"), file = newFilePath, sep = "\n", 
            append = TRUE)
        cat(paste(")"), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste(":DONE"), file = newFilePath, sep = "\n", append = TRUE)
        cat(paste("EXIT /B"), file = newFilePath, sep = "\n", 
            append = TRUE)
        if ((indx != 0) && (toupper(parallelMethod) == "MULTICORE" || 
            toupper(parallelMethod) == "NONE")) 
            shell(paste("START /B CMD /C CALL ", newFilePath))
        else {
            shell(newFilePath)
        }
    }
    DEBUG_MASTER(paste("Job ", indx, "Finished"))
    if (submissionPlatform == "unix") {
    }
    else {
    }
}
